Whamcloud - gitweb
b=13932
[fs/lustre-release.git] / lustre / tests / replay-ost-single.sh
index bd109b9..f0da27e 100755 (executable)
@@ -1,80 +1,59 @@
-#!/bin/sh
+#!/bin/bash
 
 set -e
 
+PTLDEBUG=${PTLDEBUG:--1}
 LUSTRE=${LUSTRE:-`dirname $0`/..}
+SETUP=${SETUP:-""}
+CLEANUP=${CLEANUP:-""}
 . $LUSTRE/tests/test-framework.sh
-
 init_test_env $@
-
-. ${CONFIG:=$LUSTRE/tests/cfg/local.sh}
+. ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 
 ostfailover_HOST=${ostfailover_HOST:-$ost_HOST}
+#failover= must be defined in OST_MKFS_OPTIONS if ostfailover_HOST != ost_HOST
+
+# Tests that fail on uml
+CPU=`awk '/model/ {print $4}' /proc/cpuinfo`
+[ "$CPU" = "UML" ] && EXCEPT="$EXCEPT 6"
 
 # Skip these tests
-ALWAYS_EXCEPT="5"
-# test 5 needs a larger fs than what local normally has
-
-gen_config() {
-    rm -f $XMLCONFIG
-    add_mds mds --dev $MDSDEV --size $MDSSIZE
-    add_lov lov1 mds --stripe_sz $STRIPE_BYTES\
-       --stripe_cnt $STRIPES_PER_OBJ --stripe_pattern 0
-    add_ost ost --lov lov1 --dev $OSTDEV --size $OSTSIZE --failover
-    if [ ! -z "$ostfailover_HOST" ]; then
-        add_ostfailover ost --dev $OSTDEV --size $OSTSIZE
-    fi
-    add_client client mds --lov lov1 --path $MOUNT
-}
+# BUG NUMBER: 
+ALWAYS_EXCEPT="$REPLAY_OST_SINGLE_EXCEPT"
 
-cleanup() {
-    # make sure we are using the primary MDS, so the config log will
-    # be able to clean up properly.
-    activeost=`facet_active ost`
-    if [ $activeost != "ost" ]; then
-        fail ost
-    fi
-    zconf_umount `hostname` $MOUNT
-    stop mds ${FORCE} $MDSLCONFARGS
-    stop ost ${FORCE} --dump cleanup.log
-}
+#                                      
+[ "$SLOW" = "no" ] && EXCEPT_SLOW=""
 
-if [ "$ONLY" == "cleanup" ]; then
-    sysctl -w portals.debug=0
-    cleanup
-    exit
-fi
+# It is replay-ost-single, after all
+OSTCOUNT=1
 
 build_test_filter
 
-SETUP=${SETUP:-"setup"}
-CLEANUP=${CLEANUP:-"cleanup"}
-
-setup() {
-    gen_config
+REFORMAT=--reformat cleanup_and_setup_lustre
+rm -rf $DIR/${TESTSUITE}/[df][0-9]* # bug 13798 new t-f tdir staff
+rm -rf $DIR/[df][0-9]*
 
-    start ost --reformat $OSTLCONFARGS
-    [ "$DAEMONFILE" ] && $LCTL debug_daemon start $DAEMONFILE $DAEMONSIZE
-    start mds --reformat $MDSLCONFARGS
-    zconf_mount `hostname` $MOUNT
+test_0a() {
+    zconf_umount `hostname` $MOUNT -f
+    # needs to run during initial client->OST connection
+    #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
+    do_facet ost "sysctl -w lustre.fail_loc=0x80000211"
+    zconf_mount `hostname` $MOUNT && df $MOUNT || error "0a mount fail"
 }
+run_test 0a "target handle mismatch (bug 5317) `date +%H:%M:%S`"
 
-mkdir -p $DIR
-
-$SETUP
-
-test_0() {
-    fail ost
+test_0b() {
+    fail ost1
     cp /etc/profile  $DIR/$tfile
     sync
     diff /etc/profile $DIR/$tfile
     rm -f $DIR/$tfile
 }
-run_test 0 "empty replay"
+run_test 0b "empty replay"
 
 test_1() {
     date > $DIR/$tfile
-    fail ost
+    fail ost1
     $CHECKSTAT -t file $DIR/$tfile || return 1
     rm -f $DIR/$tfile
 }
@@ -84,7 +63,7 @@ test_2() {
     for i in `seq 10`; do
         echo "tag-$i" > $DIR/$tfile-$i
     done 
-    fail ost
+    fail ost1
     for i in `seq 10`; do
       grep -q "tag-$i" $DIR/$tfile-$i || error "f2-$i"
     done 
@@ -94,10 +73,10 @@ run_test 2 "|x| 10 open(O_CREAT)s"
 
 test_3() {
     verify=$ROOT/tmp/verify-$$
-    dd if=/dev/urandom bs=1024 count=5120 | tee $verify > $DIR/$tfile &
+    dd if=/dev/urandom bs=4096 count=1280 | tee $verify > $DIR/$tfile &
     ddpid=$!
     sync &
-    fail ost
+    fail ost1
     wait $ddpid || return 1
     cmp $verify $DIR/$tfile || return 2
     rm -f $verify $DIR/$tfile
@@ -106,77 +85,93 @@ run_test 3 "Fail OST during write, with verification"
 
 test_4() {
     verify=$ROOT/tmp/verify-$$
-    dd if=/dev/urandom bs=1024 count=5120 | tee $verify > $DIR/$tfile
+    dd if=/dev/urandom bs=4096 count=1280 | tee $verify > $DIR/$tfile
     # invalidate cache, so that we're reading over the wire
-    for i in /proc/fs/lustre/ldlm/namespaces/OSC_*MNT*; do
-        echo -n clear > $i/lru_size
-    done
+    cancel_lru_locks osc
     cmp $verify $DIR/$tfile &
     cmppid=$!
-    fail ost
+    fail ost1
     wait $cmppid || return 1
     rm -f $verify $DIR/$tfile
 }
 run_test 4 "Fail OST during read, with verification"
 
 test_5() {
-    IOZONE_OPTS="-i 0 -i 1 -i 2 -+d -r 64 -s 1g"
+    [ -z "`which iozone 2> /dev/null`" ] && log "iozone missing" && return
+    FREE=`df -P -h $DIR | tail -n 1 | awk '{ print $3 }'`
+    case $FREE in
+    *T|*G) FREE=1G;;
+    esac
+    IOZONE_OPTS="-i 0 -i 1 -i 2 -+d -r 4 -s $FREE"
     iozone $IOZONE_OPTS -f $DIR/$tfile &
     PID=$!
     
-    sleep 10
-    fail ost
-    wait $PID || return 1
+    sleep 8
+    fail ost1
+    wait $PID
+    RC=$?
+    log "iozone rc=$RC"
     rm -f $DIR/$tfile
+    [ $RC -ne 0 ] && return $RC || true
 }
 run_test 5 "Fail OST during iozone"
 
 kbytesfree() {
-   cat /proc/fs/lustre/osc/OSC_*MNT*/kbytesfree | awk '{total+=$1} END {print total}'
+   awk '{total+=$1} END {print total}' /proc/fs/lustre/osc/*-osc-*/kbytesfree
 }
 
 test_6() {
     f=$DIR/$tfile
+    rm -f $f
+    sync && sleep 2 && sync    # wait for delete thread
     before=`kbytesfree`
-    dd if=/dev/urandom bs=1024 count=5120 of=$f
+    dd if=/dev/urandom bs=4096 count=1280 of=$f || return 28
+    lfs getstripe $f
+    sync
+    sleep 2                                    # ensure we have a fresh statfs
+    sync
 #define OBD_FAIL_MDS_REINT_NET_REP       0x119
     do_facet mds "sysctl -w lustre.fail_loc=0x80000119"
-    sync
     after_dd=`kbytesfree`
-    echo "before: $before after_dd: $after_dd"
-    (( before > after_dd )) || return 1
+    log "before: $before after_dd: $after_dd"
+    (( $before > $after_dd )) || return 1
     rm -f $f
-    fail ost
+    fail ost1
     $CHECKSTAT -t file $f && return 2 || true
     sync
     # let the delete happen
-    sleep 2
+    sleep 5
     after=`kbytesfree`
-    echo "before: $before after: $after"
-    (( before == after ))  || return 3
+    log "before: $before after: $after"
+    (( $before <= $after + 40 )) || return 3   # take OST logs into account
 }
 run_test 6 "Fail OST before obd_destroy"
 
 test_7() {
     f=$DIR/$tfile
+    rm -f $f
+    sync && sleep 5 && sync    # wait for delete thread
     before=`kbytesfree`
-    dd if=/dev/urandom bs=1024 count=5120 of=$f
+    dd if=/dev/urandom bs=4096 count=1280 of=$f || return 4
+    sync
+    sleep 2                                    # ensure we have a fresh statfs
     sync
     after_dd=`kbytesfree`
-    echo "before: $before after_dd: $after_dd"
-    (( before > after_dd )) || return 1
-    replay_barrier ost
+    log "before: $before after_dd: $after_dd"
+    (( $before > $after_dd )) || return 1
+    replay_barrier ost1
     rm -f $f
-    fail ost
+    fail ost1
     $CHECKSTAT -t file $f && return 2 || true
     sync
     # let the delete happen
-    sleep 2
+    sleep 5
     after=`kbytesfree`
-    echo "before: $before after: $after"
-    (( before == after )) || return 3
+    log "before: $before after: $after"
+    (( $before <= $after + 40 )) || return 3   # take OST logs into account
 }
 run_test 7 "Fail OST before obd_destroy"
 
-equals_msg test complete, cleaning up
-$CLEANUP
+equals_msg `basename $0`: test complete, cleaning up
+check_and_cleanup_lustre
+[ -f "$TESTSUITELOG" ] && cat $TESTSUITELOG || true